#!/bin/bash

# 判断脚本执行路径是否存在，如果不存在则需要设置
if [ -z $HUOJU_FTY_PATH ];
then
    echo "not found"
    export HUOJU_FTY_PATH=/root/py_script/
else
    echo "found"
fi
echo $HUOJU_FTY_PATH

###############################import操作################################

# odl.ad_tv_lib 增量更新操作
echo "执行odl_ad_tv_lib_insert任务"
python ${HUOJU_FTY_PATH}task_odl/odl_ad_tv_lib_insert.py
if [ $? -ne 0 ];
    then
        content="odl_ad_tv_lib_insert失败"
        echo $content
    exit 1
fi

# odl.ad_television 增量更新操作
echo "执行odl_ad_television_incr_update任务"
python ${HUOJU_FTY_PATH}task_odl/odl_ad_television_incr_update.py
if [ $? -ne 0 ];
    then
        content="odl_ad_television_incr_update失败"
        echo $content
    exit 1
fi

# odl.area_ad_television 增量更新操作
echo "执行odl_area_ad_television_incr_update任务"
python ${HUOJU_FTY_PATH}task_odl/odl_area_ad_television_incr_update.py
if [ $? -ne 0 ];
    then
        content="odl_area_ad_television_incr_update失败"
        echo $content
    exit 1
fi

# odl.ad_audience_cps_time_incr_update 导入操作
echo "执行odl_ad_audience_cps_time_incr_update任务"
python ${HUOJU_FTY_PATH}task_odl/odl_ad_audience_cps_time_incr_update.py
if [ $? -ne 0 ];
    then
        content="odl_ad_audience_cps_time_incr_update失败"
        echo $content
    exit 1
fi
echo "导入脚本执行完毕"

# 月份提取
echo "执行tmp_data_month任务"
python ${HUOJU_FTY_PATH}task_tmp/tmp_data_month.py
if [ $? -ne 0 ];
    then
        content="任务tmp_data_month失败"
        echo $content
    exit 1
fi

echo "月份提取完毕"