#!/bin/bash

# 判断脚本执行路径是否存在，如果不存在则需要设置
if [ -z $HUOJU_FTY_PATH ];
then 
    echo "not found"
    export HUOJU_FTY_PATH=/root/py_script/
else
    echo "found"
fi
echo $HUOJU_FTY_PATH

###############################scrapy操作################################

# 新剧营销文章链接爬取
echo "执行scrapy_website_count_new任务"
python ${HUOJU_FTY_PATH}task_scrapy/scrapy_website_count_new.py
if [ $? -ne 0 ];
    then
        content="任务scrapy_website_count_new失败"
        echo $content
    exit 1
fi

# 营销文章数量爬取
echo "执行scrapy_website_count任务"
python ${HUOJU_FTY_PATH}task_scrapy/scrapy_website_count.py
if [ $? -ne 0 ];
    then
        content="任务scrapy_website_count失败"
        echo $content
    exit 1
fi

# 从爱奇艺上爬取百科上未被爬到的电视剧
echo "执行scrapy_tv_unhandle任务"
python ${HUOJU_FTY_PATH}task_scrapy/scrapy_tv_unhandle.py
if [ $? -ne 0 ];
    then
        content="任务scrapy_tv_unhandle失败"
        echo $content
    exit 1
fi