#!/usr/bin/env python
#coding=utf-8

"""将tv_category_scrapy表中的分类数据(多个)分割存到分类关联表中，记录为tv_id - category

"""

import sys
import os
import datetime
from fty_util.common import Mysql
import time

reload(sys)
sys.setdefaultencoding('utf8')

conn = Mysql.createOfflineConn()
# 清空走势数据

sql = """
    select id, types from scrapy.tv_category_scrapy where types is not null and types != '' order by id asc
"""

rows = Mysql.getAll(sql, conn=conn)
for row in rows:
    _id = row['id']
    types = row['types']

    type_list = types.split(' ')
    
    sql_insert = """
        insert into odl.tv_category_relation (tv_id, category) values (%s, %s)
    """
    data_list = []
    for _type in type_list:
        data_list.append((_id, _type))
    Mysql.insertMany(sql_insert, data_list, conn)

Mysql.close(conn)